<?php
/*
Plugin Name: Where did they go from here?
Version: 1.4
Plugin URI: http://weblogtoolscollection.com/archives/2007/06/04/wp-plugin-where-did-they-go-from-here/
Description: Show "Readers who viewed this page, also viewed" links on your page. Much like Amazon.com's product pages.
Author: Mark Ghosh (LaughingLizard)
Author URI: http://weblogtoolscollection.com

Copyright (c) 2004
Released under the GPL license
http://www.gnu.org/licenses/gpl.txt

    This file is part of WordPress.
    WordPress is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	INSTALL: 
	Unzip Plugin, upload to wp-content/plugins folder, activate
	
	LEGAL:
	GPL Copyright as above, Tested on WP 2.1+, No warranties promised or implied, use at your own risk
	
	TROUBLESHOOT:
	Must have default actions in theme for the list to show up. If list does not show, add the following line to your single.php in your theme.
	<?php if (function_exists('show_where_they_go')) show_where_they_go(); ?>

*/

// Max number of links to keep
$maxLinks = 5;

add_action('wp_footer','add_wherego_count');

function add_wherego_count() {
	global $wpdb, $single, $post, $maxLinks;
	$siteurl = get_option('siteurl');
	$sitevar =  attribute_escape($_SERVER['HTTP_REFERER']);
	$tempsitevar =  attribute_escape($_SERVER['HTTP_REFERER']);
        $siteurl = str_replace("http:","",$siteurl);
	$siteurl = str_replace("/","",$siteurl);
        $sitevar = str_replace("/","\/",$sitevar);
	$matchvar = preg_match("/$siteurl/i", $sitevar);
	$id = $post->ID;	
	if ($single && isset($id) && $id > 0 && $matchvar) {	
		// Now figure out the ID of the post the author came from, this might be hokey at first
		// Text search within code is your friend!
		$postIDcamefrom = url_to_postid($tempsitevar);
		if ('' != $postIDcamefrom && $id != $postIDcamefrom && '' != $id) {
			$gotmeta = '';
			$linkpostids = get_post_meta($postIDcamefrom, 'wheredidtheycomefrom', true);
			if ($linkpostids && '' != $linkpostids) {
				$gotmeta = true;
			}
			else {
				$gotmeta = false;
				$linkpostids = array();
			}
			
			if (is_array($linkpostids) && !in_array($id,$linkpostids) && $gotmeta) {
				array_unshift($linkpostids,$id);
			}		
                        elseif (is_array($linkpostids) && !$gotmeta)    {
                                $linkpostids[0] = $id;
                        }

			//Make sure we only keep maxLinks number of links
			if (count($linkpostids) > $maxLinks) {
				$linkpostids = array_slice($linkpostids, 0, $maxLinks);
			}
			$linkpostidsserialized = $linkpostids;
			if ($gotmeta && !empty($linkpostids))
				return update_post_meta($postIDcamefrom, 'wheredidtheycomefrom', $linkpostidsserialized);
			else
				return add_post_meta($postIDcamefrom, 'wheredidtheycomefrom', $linkpostidsserialized);
		}		
		else
			return 0; // break out, we could not determine the post ID, nothing to keep
	}
}

function show_where_they_go() {
	global $wpdb, $siteurl, $tableposts, $post;
	$lpids = get_post_meta($post->ID, 'wheredidtheycomefrom', true);
	echo "<h3>Readers who viewed this page, also viewed:</h3><ul>";
	if ($lpids) {
		foreach ($lpids as $lpid) {
			echo '<li><a href="'.get_permalink($lpid).'">'.get_the_title($lpid).'</a></li>';
		}
	}
	else
		echo '<li>N/A</li>';
	echo "</ul>";
}

add_action('comment_form','show_where_they_go');

?>